<?php

namespace backend\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use common\models\EventRegistration;

/**
 * EventRegistrationSearch represents the model behind the search form about `common\models\EventRegistration`.
 */
class EventRegistrationSearch extends EventRegistration
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id', 'id_event', 'id_customer'], 'integer'],
            [['created_at', 'updated_at', 'canceled_at'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = EventRegistration::find();

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'id' => $this->id,
            'id_event' => $this->id_event,
            'id_customer' => $this->id_customer,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,
            'canceled_at' => $this->canceled_at,
        ]);

        return $dataProvider;
    }
}
